Index: src/sans/perspectives/fitting/fit_thread.py
===================================================================
--- src/sans/perspectives/fitting/fit_thread.py	(revision a855fec9ef18808f7423a1337764d7758ed5a7b8)
+++ src/sans/perspectives/fitting/fit_thread.py	(revision e3efa6b33f61b244c04b2476cabdadf01a183b76)
@@ -18,10 +18,10 @@
     
     def __init__(self, 
-                  fn,
-                  page_id,
-                   handler,
-                    batch_outputs,
-                    batch_inputs=None,             
-                  pars=None,
+                 fn,
+                 page_id,
+                 handler,
+                 batch_outputs,
+                 batch_inputs=None,
+                 pars=None,
                  completefn = None,
                  updatefn   = None,
@@ -30,5 +30,6 @@
                  ftol       = None,
                  reset_flag = False):
-        CalcThread.__init__(self,completefn,
+        CalcThread.__init__(self,
+                 completefn,
                  updatefn,
                  yieldtime,
@@ -80,6 +81,6 @@
                 list_map_get_attr.append(map_getattr)
             #from multiprocessing import Pool
-            inputs = zip(list_map_get_attr,self.fitter, list_fit_function,
-                          list_q, list_q, list_handler,list_curr_thread,list_ftol,
+            inputs = zip(list_map_get_attr, self.fitter, list_fit_function,
+                         list_q, list_q, list_handler,list_curr_thread,list_ftol,
                          list_reset_flag)
             result =  map(map_apply, inputs)
@@ -87,5 +88,5 @@
             self.complete(result=result,
                           batch_inputs=self.batch_inputs,
-                           batch_outputs=self.batch_outputs,
+                          batch_outputs=self.batch_outputs,
                           page_id=self.page_id,
                           pars = self.pars,
Index: src/sans/perspectives/fitting/fitpage.py
===================================================================
--- src/sans/perspectives/fitting/fitpage.py	(revision d44648e2796f06ea09546b0c972320f42957b07f)
+++ src/sans/perspectives/fitting/fitpage.py	(revision 4e9f22702695459c7a6c8721061aab9d9e4ef437)
@@ -661,5 +661,5 @@
                           wx.EXPAND | wx.ADJUST_MINSIZE, 0)
         
-        if self.engine_type == "park":
+        if self.engine_type in ("park","bumps"):
             self.text_disp_max.Show(True)
             self.text_disp_min.Show(True)
@@ -738,5 +738,5 @@
                                           wx.EXPAND | wx.ADJUST_MINSIZE, 0)
 
-                        if self.engine_type == "park":
+                        if self.engine_type in ("park","bumps"):
                             ctl3.Show(True)
                             ctl4.Show(True)
@@ -1005,8 +1005,8 @@
             return
 
-        if len(self._manager.fit_thread_list) > 0 and\
-                    self._manager._fit_engine != "park" and\
-                    self._manager.sim_page != None and \
-                    self._manager.sim_page.uid == self.uid:
+        if (len(self._manager.fit_thread_list) > 0
+                and self._manager._fit_engine not in ("park","bumps")
+                and self._manager.sim_page != None
+                and self._manager.sim_page.uid == self.uid):
             msg = "The FitEnging will be set to 'ParkMC'\n"
             msg += " to fit with more than one data set..."
@@ -2068,19 +2068,4 @@
         return self.tcChi.GetValue()
         
-    def get_param_list(self):
-        """
-        :return self.param_toFit: list containing  references to TextCtrl
-            checked.Theses TextCtrl will allow reference to parameters to fit.
-        
-        :raise: if return an empty list of parameter fit will nnote work
-            properly so raise ValueError,"missing parameter to fit"
-        """
-        if self.param_toFit != []:
-            return self.param_toFit
-        else:
-            msg = "missing parameters to fit"
-            wx.MessageBox(msg, 'warning')
-            return False
-      
     def onsetValues(self, chisqr, p_name, out, cov):
         """
@@ -2108,5 +2093,5 @@
         if chisqr != None and numpy.isfinite(chisqr):
             #format chi2
-            if self.engine_type == "park":
+            if self.engine_type in ("park","bumps"):
                 npt_fit = float(self.get_npts2fit())
             chi2 = format_number(chisqr, True)
Index: src/sans/perspectives/fitting/fitpanel.py
===================================================================
--- src/sans/perspectives/fitting/fitpanel.py	(revision b6a181b3c69394fc4ac616d07590369465589b85)
+++ src/sans/perspectives/fitting/fitpanel.py	(revision eff93b8d577de85b34ffd99e484da07484c35580)
@@ -64,5 +64,5 @@
         self.sim_page = None
         self.batch_page = None
-        self.fit_engine_type = "scipy"
+        self.fit_engine_type = "bumps"
         ## get the state of a page
         self.Bind(basepage.EVT_PAGE_INFO, self._onGetstate)
Index: src/sans/perspectives/fitting/fitting.py
===================================================================
--- src/sans/perspectives/fitting/fitting.py	(revision 767514afc7aa3ac5ba01c3f093481cdb65966863)
+++ src/sans/perspectives/fitting/fitting.py	(revision eff93b8d577de85b34ffd99e484da07484c35580)
@@ -36,4 +36,6 @@
 from .fitproblem import FitProblemDictionary
 from .fitpanel import FitPanel
+from .resultpanel import ResultPanel, PlotResultEvent
+
 from .fit_thread import FitThread
 from .pagestate import Reader
@@ -42,4 +44,9 @@
 from sans.perspectives.calculator.model_editor import EditorWindow
 from sans.guiframe.gui_manager import MDIFrame
+
+# TODO: remove globals from interface to bumps options!
+# Default bumps to use the levenberg-marquardt optimizer
+import bumps.fitters
+bumps.fitters.FIT_DEFAULT = 'lm'
 
 MAX_NBR_DATA = 4
@@ -78,9 +85,5 @@
         # Start with a good default
         self.elapsed = 0.022
-        # the type of optimizer selected, park or scipy
-        self.fitter = None
         self.fit_panel = None
-        #let fit ready
-        self.fitproblem_count = None
         #Flag to let the plug-in know that it is running stand alone
         self.standalone = True
@@ -88,5 +91,5 @@
         self.closed_page_dict = {}
         ## Fit engine
-        self._fit_engine = 'scipy'
+        self._fit_engine = 'bumps'
         self._gui_engine = None
         ## Relative error desired in the sum of squares (float); scipy only
@@ -111,4 +114,5 @@
         self.scipy_id = wx.NewId()
         self.park_id = wx.NewId()
+        self.bumps_id = wx.NewId()
         self.menu1 = None
         self.new_model_frame = None
@@ -198,6 +202,12 @@
         wx.EVT_MENU(owner, self.park_id, self._onset_engine_park)
         
-        self.menu1.FindItemById(self.scipy_id).Check(True)
-        self.menu1.FindItemById(self.park_id).Check(False)
+        bumps_help = "Bumps: fitting and uncertainty analysis. More in Help window...."
+        self.menu1.AppendCheckItem(self.bumps_id, "Bumps fit",
+                                   bumps_help)
+        wx.EVT_MENU(owner, self.bumps_id, self._onset_engine_bumps)
+        
+        self.menu1.FindItemById(self.scipy_id).Check(self._fit_engine=="scipy")
+        self.menu1.FindItemById(self.park_id).Check(self._fit_engine=="park")
+        self.menu1.FindItemById(self.bumps_id).Check(self._fit_engine=="bumps")
         self.menu1.AppendSeparator()
         self.id_tol = wx.NewId()
@@ -207,4 +217,15 @@
                                    ftol_help)
         wx.EVT_MENU(owner, self.id_tol, self.show_ftol_dialog)
+
+        self.id_bumps_options = wx.NewId()
+        bopts_help = "Bumps fitting options"
+        self.menu1.Append(self.id_bumps_options, 'Bumps &Options', bopts_help)
+        wx.EVT_MENU(owner, self.id_bumps_options, self.on_bumps_options)
+        self.bumps_options_menu = self.menu1.FindItemById(self.id_bumps_options)
+        self.bumps_options_menu.Enable(True)
+
+        self.id_result_panel = wx.NewId()
+        self.menu1.Append(self.id_result_panel, "Fit Results", "Show fit results panel")
+        wx.EVT_MENU(owner, self.id_result_panel, lambda ev: self.result_frame.Show())
         self.menu1.AppendSeparator()
         
@@ -511,4 +532,8 @@
         self.perspective = []
         self.perspective.append(self.fit_panel.window_name)
+
+        self.result_frame = MDIFrame(self.parent, None, ResultPanel.window_caption, (220, 200))
+        self.result_panel = ResultPanel(parent=self.result_frame, manager=self)
+        self.perspective.append(self.result_panel.window_name)
        
         #index number to create random model name
@@ -525,4 +550,5 @@
         #Send the fitting panel to guiframe
         self.mypanels.append(self.fit_panel)
+        self.mypanels.append(self.result_panel)
         return self.mypanels
     
@@ -818,4 +844,8 @@
                          StatusEvent(status=msg, info='warning'))
         dialog.Destroy()
+
+    def on_bumps_options(self, event=None):
+        from bumps.gui.fit_dialog import OpenFitOptions
+        OpenFitOptions()
 
     def stop_fit(self, uid):
@@ -951,62 +981,58 @@
         :param uid: id related to the panel currently calling this fit function.
         """
-        flag = True
-        ##  count the number of fitproblem schedule to fit
-        fitproblem_count = 0
-        for value in self.page_finder.values():
-            if value.get_scheduled() == 1:
-                fitproblem_count += 1
-        self._gui_engine = self._return_engine_type()
-        self.fitproblem_count = fitproblem_count
-        if self._fit_engine == "park":
-            engineType = "Simultaneous Fit"
+        if uid is None: raise RuntimeError("no page to fit") # Should never happen
+
+        # Remember the user selected fit engine before the fit.  Simultaneous
+        # fitting may change the selected engine, so it needs to be restored
+        # when the fit is complete.
+        self._gui_engine = self._fit_engine
+
+        sim_page_uid = getattr(self.sim_page, 'uid', None)
+        batch_page_uid = getattr(self.batch_page, 'uid', None)
+
+        if uid == sim_page_uid:
+            fit_type = 'simultaneous'
+        elif uid == batch_page_uid:
+            fit_type = 'combined_batch'
         else:
-            engineType = "Single Fit"
+            fit_type = 'single'
+
+        # if constrained fit, don't use scipy leastsq directly
+        if fit_type == 'simultaneous':
+            if self._fit_engine not in ("park","bumps"):
+                self._on_change_engine(engine='bumps')
+
+
         fitter_list = []
         sim_fitter = None
-        is_single_fit = True
-        batch_on = False
-        if self.sim_page is not None and self.sim_page.uid == uid:
+        if fit_type == 'simultaneous':
             #simulatanous fit only one engine need to be created
-            ## if simultaneous fit change automatically the engine to park
-            self._on_change_engine(engine='park')
             sim_fitter = Fit(self._fit_engine)
             sim_fitter.fitter_id = self.sim_page.uid
             fitter_list.append(sim_fitter)
-            is_single_fit = False
-            batch_on = self.sim_page.batch_on
-            
-        self.fitproblem_count = fitproblem_count
-        if self._fit_engine == "park":
-            engineType = "Simultaneous Fit"
-        else:
-            engineType = "Single Fit"
-        
+
         self.current_pg = None
         list_page_id = []
         fit_id = 0
-        batch_inputs = {}
-        batch_outputs = {}
-        for page_id, value in self.page_finder.iteritems():
+        for page_id, page_info in self.page_finder.iteritems():
             # For simulfit (uid give with None), do for-loop
             # if uid is specified (singlefit), do it only on the page.
-            if engineType == "Single Fit":
-                #combine more than 1 batch page on single mode
-                if self.batch_page is None or self.batch_page.uid != uid:
-                    if page_id != uid:
-                        continue
+            if page_id in (sim_page_uid, batch_page_uid): continue
+            if fit_type == "single" and page_id != uid: continue
+
             try:
-                if value.get_scheduled() == 1:
-                    value.nbr_residuals_computed = 0
-                    #Get list of parameters name to fit
-                    pars = []
-                    templist = []
+                if page_info.get_scheduled() == 1:
+                    page_info.nbr_residuals_computed = 0
                     page = self.fit_panel.get_page_by_id(page_id)
                     self.set_fit_weight(uid=page.uid,
                                      flag=page.get_weight_flag(),
                                      is2d=page._is_2D())
-                    templist = page.get_param_list()
-                    flag = page._update_paramv_on_fit()
-                    if not flag:
+                    if not page.param_toFit:
+                        msg = "No fitting parameters for %s"%page.window_caption
+                        wx.PostEvent(page.parent.parent,
+                                     StatusEvent(status=msg, info="error",
+                                                 type="stop"))
+                        return False
+                    if not page._update_paramv_on_fit():
                         msg = "Fitting range or parameter values are"
                         msg += " invalid in %s" % \
@@ -1015,44 +1041,32 @@
                                      StatusEvent(status=msg, info="error",
                                      type="stop"))
-                        return flag
-                    for element in templist:
-                        name = str(element[1])
-                        pars.append(name)
-                    fitproblem_list = value.values()
+                        return False
+
+                    pars = [str(element[1]) for element in page.param_toFit]
+                    fitproblem_list = page_info.values()
                     for fitproblem in  fitproblem_list:
                         if sim_fitter is None:
                             fitter = Fit(self._fit_engine)
                             fitter.fitter_id = page_id
-                            self._fit_helper(fitproblem=fitproblem,
-                                             pars=pars,
-                                             fitter=fitter,
-                                             fit_id=fit_id,
-                                             batch_inputs=batch_inputs,
-                                             batch_outputs=batch_outputs)
                             fitter_list.append(fitter)
                         else:
                             fitter = sim_fitter
-                            self._fit_helper(fitproblem=fitproblem,
+                        self._add_problem_to_fit(fitproblem=fitproblem,
                                              pars=pars,
                                              fitter=fitter,
-                                             fit_id=fit_id,
-                                             batch_inputs=batch_inputs,
-                                             batch_outputs=batch_outputs)
+                                             fit_id=fit_id)
                         fit_id += 1
                     list_page_id.append(page_id)
-                    current_page_id = page_id
-                    value.clear_model_param()
+                    page_info.clear_model_param()
             except KeyboardInterrupt:
-                flag = True
                 msg = "Fitting terminated"
                 wx.PostEvent(self.parent, StatusEvent(status=msg, info="info",
                                                       type="stop"))
-                return flag
+                return True
             except:
-                flag = False
-                msg = "%s error: %s" % (engineType, sys.exc_value)
+                msg = "Fitting error: %s" % str(sys.exc_value)
                 wx.PostEvent(self.parent, StatusEvent(status=msg, info="error",
                                                       type="stop"))
-                return flag
+                return False
         ## If a thread is already started, stop it
         #if self.calc_fit!= None and self.calc_fit.isrunning():
@@ -1066,21 +1080,10 @@
                                 improvement_delta=0.1)
         self._mac_sleep(0.2)
-        ## perform single fit
-        try:
-            page = self.fit_panel.get_page_by_id(uid)
-            batch_on = page.batch_on
-        except:
-            try:
-                #if the id cannot be found then  we deal with a self.sim_page
-                #or a self.batch_page
-                if self.sim_page is not None and uid == self.sim_page.uid:
-                    batch_on = self.sim_page.batch_on
-                if self.batch_page is not None and uid == self.batch_page.uid:
-                    batch_on = self.batch_page.batch_on
-            except:
-                batch_on = False
 
         # batch fit
-        if batch_on:
+        batch_inputs = {}
+        batch_outputs = {}
+        page = self.fit_panel.get_page_by_id(uid)
+        if page.batch_on:
             calc_fit = FitThread(handler=handler,
                                  fn=fitter_list,
@@ -1093,7 +1096,4 @@
                                  reset_flag=self.batch_reset_flag)
         else:
-            # single fit: not batch and not simul fit
-            if not is_single_fit:
-                current_page_id = self.sim_page.uid
             ## Perform more than 1 fit at the time
             calc_fit = FitThread(handler=handler,
@@ -1105,21 +1105,13 @@
                                     completefn=self._fit_completed,
                                     ftol=self.ftol)
-        self.fit_thread_list[current_page_id] = calc_fit
+        #self.fit_thread_list[current_page_id] = calc_fit
+        self.fit_thread_list[uid] = calc_fit
         calc_fit.queue()
+        calc_fit.ready(2.5)
         msg = "Fitting is in progress..."
         wx.PostEvent(self.parent, StatusEvent(status=msg, type="progress"))
         
-        self.ready_fit(calc_fit=calc_fit)
-        return flag
-    
-    def ready_fit(self, calc_fit):
-        """
-        Ready for another fit
-        """
-        if self.fitproblem_count != None and self.fitproblem_count > 1:
-            calc_fit.ready(2.5)
-        else:
-            time.sleep(0.4)
-            
+        return True
+
     def remove_plot(self, uid, fid=None, theory=False):
         """
@@ -1261,6 +1253,5 @@
                 self.page_finder[uid].schedule_tofit(value)
                 
-    def _fit_helper(self, fitproblem, pars, fitter, fit_id,
-                    batch_inputs, batch_outputs):
+    def _add_problem_to_fit(self, fitproblem, pars, fitter, fit_id):
         """
         Create and set fit engine with series of data and model
@@ -1571,4 +1562,5 @@
         wx.PostEvent(self.parent, StatusEvent(status=msg, info="info",
                                                       type="stop"))
+        wx.PostEvent(self.result_panel, PlotResultEvent(result=result))
         # reset fit_engine if changed by simul_fit
         if self._fit_engine != self._gui_engine:
@@ -1682,4 +1674,10 @@
         self._on_change_engine('scipy')
        
+    def _onset_engine_bumps(self, event):
+        """ 
+        set engine to bumps
+        """
+        self._on_change_engine('bumps')
+       
     def _on_slicer_event(self, event):
         """
@@ -1714,10 +1712,4 @@
                 break
     
-    def _return_engine_type(self):
-        """
-        return the current type of engine
-        """
-        return self._fit_engine
-     
     def _on_change_engine(self, engine='park'):
         """
@@ -1733,7 +1725,13 @@
             self.menu1.FindItemById(self.park_id).Check(True)
             self.menu1.FindItemById(self.scipy_id).Check(False)
+            self.menu1.FindItemById(self.bumps_id).Check(False)
+        elif engine == "scipy":
+            self.menu1.FindItemById(self.park_id).Check(False)
+            self.menu1.FindItemById(self.scipy_id).Check(True)
+            self.menu1.FindItemById(self.bumps_id).Check(False)
         else:
             self.menu1.FindItemById(self.park_id).Check(False)
-            self.menu1.FindItemById(self.scipy_id).Check(True)
+            self.menu1.FindItemById(self.scipy_id).Check(False)
+            self.menu1.FindItemById(self.bumps_id).Check(True)
         ## post a message to status bar
         msg = "Engine set to: %s" % self._fit_engine
Index: src/sans/perspectives/fitting/resultpanel.py
===================================================================
--- src/sans/perspectives/fitting/resultpanel.py	(revision ed4aef2412e82813a3c69fc3d050687b22a157ad)
+++ src/sans/perspectives/fitting/resultpanel.py	(revision ed4aef2412e82813a3c69fc3d050687b22a157ad)
@@ -0,0 +1,85 @@
+"""
+FitPanel class contains fields allowing to fit  models and  data
+
+:note: For Fit to be performed the user should check at least one parameter
+    on fit Panel window.
+   
+"""
+import wx
+import wx.lib.newevent
+from wx.aui import AuiNotebook as Notebook
+
+from sans.guiframe.panel_base import PanelBase
+from sans.guiframe.events import StatusEvent
+
+(PlotResultEvent, EVT_PLOT_RESULT) = wx.lib.newevent.NewEvent()
+
+
+class ResultPanel(Notebook, PanelBase):
+    """
+    FitPanel class contains fields allowing to fit  models and  data
+    
+    :note: For Fit to be performed the user should check at least one parameter
+        on fit Panel window.
+       
+    """
+    ## Internal name for the AUI manager
+    window_name = "Result panel"
+    ## Title to appear on top of the window
+    window_caption = "Result Panel"
+    CENTER_PANE = True
+    
+    def __init__(self, parent, manager=None, *args, **kwargs):
+        """
+        """
+        style = ((wx.aui.AUI_NB_WINDOWLIST_BUTTON
+                 |wx.aui.AUI_NB_DEFAULT_STYLE
+                 |wx.CLIP_CHILDREN)
+                 & ~wx.aui.AUI_NB_CLOSE_ON_ACTIVE_TAB)
+        Notebook.__init__(self, parent, -1, style = style)
+        PanelBase.__init__(self, parent)
+        self.frame = parent
+        self.Bind(EVT_PLOT_RESULT, self.on_plot_results)
+        self.frame.Bind(wx.EVT_CLOSE, self.on_close)
+        self._manager = None
+
+    def on_close(self, event):
+        if event.CanVeto():
+            self.frame.Hide()
+            event.Veto()
+        else:
+            event.Skip()
+
+    def on_plot_results(self, event):
+        self.frame.Show()
+        result = event.result[0][0]
+        if hasattr(result, 'convergence'):
+            from bumps.gui.convergence_view import ConvergenceView
+            best, pop = result.convergence[:,0], result.convergence[:,1:]
+            self.get_panel(ConvergenceView).update(best, pop)
+        if hasattr(result, 'uncertainty_state'):
+            from bumps.gui.uncertainty_view import UncertaintyView, CorrelationView, TraceView
+            from bumps.dream.stats import format_vars
+            self.get_panel(CorrelationView).update(result.uncertainty_state)
+            self.get_panel(UncertaintyView).update(result.uncertainty_state)
+            self.get_panel(TraceView).update(result.uncertainty_state)
+            # TODO: stats should be stored in result rather than computed in bumps UncertaintyView
+            msg = format_vars(self.get_panel(UncertaintyView).stats)
+            wx.PostEvent(self.frame.parent,
+                         StatusEvent(status=msg, info="info"))
+            print
+
+    def get_frame(self):
+        return self.frame
+
+    def add_panel(self, panel):
+        self.AddPage(panel, panel.title)
+
+    def get_panel(self, panel_class):
+        for idx in range(self.PageCount):
+            if self.GetPageText(idx) == panel_class.title:
+                return self.GetPage(idx)
+        else:
+            panel = panel_class(self)
+            self.add_panel(panel)
+            return panel
Index: src/sans/perspectives/fitting/simfitpage.py
===================================================================
--- src/sans/perspectives/fitting/simfitpage.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/perspectives/fitting/simfitpage.py	(revision 4e9f22702695459c7a6c8721061aab9d9e4ef437)
@@ -138,5 +138,11 @@
                 self.Layout()
                 break
-        self._onAdd_constraint(None)
+
+        ## some model or parameters can be constrained
+        self._show_constraint()
+        self.sizer3.Layout()
+        self.Layout()
+        self.Refresh()
+        #self._onAdd_constraint(None)
              
     def onFit(self, event):
@@ -152,5 +158,5 @@
         ## making sure all parameters content a constraint
         ## validity of the constraint expression is own by fit engine
-        if self.parent._manager._fit_engine != "park" and flag:
+        if self.parent._manager._fit_engine not in ("park","bumps") and flag:
             msg = "The FitEnging will be set to 'Park' fit engine\n"
             msg += " for the simultaneous fit..."
@@ -378,5 +384,5 @@
         box_description = wx.StaticBox(self, -1,"Easy Setup ")
         boxsizer = wx.StaticBoxSizer(box_description, wx.HORIZONTAL)     
-        sizer_constraint = wx.BoxSizer(wx.HORIZONTAL|wx.LEFT|wx.RIGHT|wx.EXPAND)
+        sizer_constraint = wx.BoxSizer(wx.HORIZONTAL)
         self.model_cbox_left = wx.ComboBox(self, -1, style=wx.CB_READONLY)
         self.model_cbox_left.Clear()
Index: test/park_integration/test/batch_fit.py
===================================================================
--- test/park_integration/test/batch_fit.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ test/park_integration/test/batch_fit.py	(revision e3efa6b33f61b244c04b2476cabdadf01a183b76)
@@ -1,6 +1,2 @@
-
-
-import math
-import numpy
 import copy
 import time
@@ -15,6 +11,4 @@
 
 
-
-    
 def classMapper(classInstance, classFunc, *args):
     """
@@ -28,6 +22,5 @@
 
 
-
-class BatchScipyFit:
+class BatchFit:
     """
     test fit module
@@ -69,5 +62,5 @@
             model.setParam('cyl_phi.npts', 3)
             model.setParam('cyl_theta.nsigmas', 10)
-            """ for 2 data cyl_theta = 60.0 [deg] cyl_phi= 60.0 [deg]"""
+            # for 2 data cyl_theta = 60.0 [deg] cyl_phi= 60.0 [deg]
             fitter.set_model(model, i, self.param_to_fit, 
                              self.list_of_constraints)
@@ -84,5 +77,5 @@
             self.list_of_mapper.append(classMapper)
                    
-    def reset_value(self):
+    def reset_value(self, engine='scipy'):
         """
         Initialize inputs for the map function
@@ -93,6 +86,5 @@
         self.list_of_constraints = []
         self.list_of_mapper = []
-        engine ="scipy"
-        
+
         path = "testdata_line3.txt"
         self._reset_helper(path=path, engine=engine, npts=NPTS)
@@ -113,11 +105,14 @@
         
       
-    def test_map_fit(self):
+    def test_map_fit(self, n=0):
         """
-        """ 
-        results =  map(classMapper,self.list_of_fitter, self.list_of_function)
-        print len(results)
-        for result in results:
-            print result.fitness, result.stderr, result.pvec
+        """
+        if n > 0:
+            self._test_process_map_fit(n=n)
+        else:
+            results =  map(classMapper,self.list_of_fitter, self.list_of_function)
+            print len(results)
+            for result in results:
+                print result.fitness, result.stderr, result.pvec
         
     def test_process_map_fit(self, n=1):
@@ -144,16 +139,17 @@
     """  
     def setUp(self):
-        self.test = BatchScipyFit(qmin=None, qmax=None)
+        self.test = BatchFit(qmin=None, qmax=None)
        
     
-    def __test_fit1(self):
+    def test_fit1(self):
         """test fit with python built in map function---- full range of each data"""
         self.test.test_map_fit()
         
-    def __test_fit2(self):
+    def test_fit2(self):
         """test fit with python built in map function---- common range for all data"""
         self.test.set_range(qmin=0.013, qmax=0.05)
         self.test.reset_value()
         self.test.test_map_fit()
+        raise Exception("fail")
         
     def test_fit3(self):
@@ -161,5 +157,5 @@
         self.test.set_range(qmin=None, qmax=None)
         self.test.reset_value()
-        self.test.test_process_map_fit(n=2)
+        self.test.test_map_fit(n=1)
         
     def test_fit4(self):
@@ -167,5 +163,5 @@
         self.test.set_range(qmin=-1, qmax=10)
         self.test.reset_value()
-        self.test.test_process_map_fit(n=1)
+        self.test.test_map_fit(n=3)
         
             
